/********************************************************************************
 * Copyright (c) 2023 CEA-List
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************/

#include <pybind11/pybind11.h>

#include "aidge/operator/Resize.hpp"
#include "aidge/operator/OperatorTensor.hpp"

namespace py = pybind11;
namespace Aidge {

void init_Resize(py::module& m) {
    py::class_<Resize_Op, std::shared_ptr<Resize_Op>, OperatorTensor>(m, "ResizeOp", py::multiple_inheritance())
        .def_static("get_inputs_name", &Resize_Op::getInputsName)
        .def_static("get_outputs_name", &Resize_Op::getOutputsName);

    declare_registrable<Resize_Op>(m, "ResizeOp");

    m.def("Resize", &Resize, py::arg("name") = "");
}
}  // namespace Aidge
